class AppTapConfigUtils {
  static AppTapConfigUtils _instance;
  static AppTapConfigUtils getInstance() {
    if (_instance == null) {
      _instance = new AppTapConfigUtils();
    }
    return _instance;
  }

  OnActivityConfigTapListener _activityConfigTapListener;
  OnGoodsTapListener _goodsTapListener;
  OnPriceGoodsTapListener _priceGoodsTapListener;

  void activityConfigTap(Map<String, dynamic> jsonStr) {
    if (_activityConfigTapListener != null) {
      _activityConfigTapListener(jsonStr);
    }
  }

  void setOnActivityConfigTapListener(OnActivityConfigTapListener t) {
    _activityConfigTapListener = t;
  }

  void setOnPriceGoodsTapListener(OnPriceGoodsTapListener t) {
    _priceGoodsTapListener = t;
  }

  void priceGoodsTap({
    String productId,
    String src,
    String title,
    String remark,
  }) {
    if (_priceGoodsTapListener != null) {
      _priceGoodsTapListener(
        productId: productId,
        src: src,
        title: title,
        remark: remark,
      );
    }
  }

  void goodsTap({
    String platform,
    String itemId,
    Map goodsItem,
    String tabviewId,
  }) {
    if (_goodsTapListener != null) {
      _goodsTapListener(
        platform: platform,
        itemId: itemId,
        goodsItem: goodsItem,
        tabviewId: tabviewId,
      );
    }
  }

  void setOnGoodsTapListener(OnGoodsTapListener t) {
    _goodsTapListener = t;
  }
}

typedef OnActivityConfigTapListener = Function(Map<String, dynamic> jsonStr);
typedef OnGoodsTapListener = Function({
  String platform,
  String itemId,
  Map goodsItem,
  String tabviewId,
});
typedef OnPriceGoodsTapListener = Function({
  String productId,
  String src,
  String title,
  String remark,
});
