import 'package:common_module/utils/store_utils.dart';

const String _AUDIT_MODE_CACHE_KEY = "";

/// 审核模式工具类
class AuditModeUtils {
  static AuditModeUtils _instance;

  static AuditModeUtils getInstance() {
    if (_instance == null) {
      _instance = new AuditModeUtils._();
    }
    return _instance;
  }

  AuditModeUtils._();

  String _isAuditMode;
  String _adSwitch;

  // 获取是否审核模式
  bool isAuditMode() {
    if (_isAuditMode == null) {
      _isAuditMode =
          StoreUtils.getInstance().getForKey(key: _AUDIT_MODE_CACHE_KEY,defaultValue: null);
    }
    return _isAuditMode == '1';
  }

  ///
  /// 是否开启广告
  /// 2为隐藏
  ///
  bool isHideAdSwitch(){
    return (_adSwitch == '2');
  }

  void setAdSwitch(String adSwitch){
    _adSwitch = adSwitch;
  }

  void setAuditMode(String isAuditMode) {
    StoreUtils.getInstance().setKV(key: _AUDIT_MODE_CACHE_KEY, value: isAuditMode);
    _isAuditMode = isAuditMode;
  }
}
