import 'package:flutter/material.dart';
import 'package:common_module/utils/xapp_utils.dart';
import 'package:mvp/mvp.dart';

class ScrollToTopWidget extends StatelessWidget {
  final ScrollToModel model;
  const ScrollToTopWidget({Key key, this.model}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return QMProvider<ScrollToModel>.value(
      model: model,
      builderWidget: (context, model, child) => Offstage(
        offstage: !model.showFloatingButton,
        child: Container(
          margin: EdgeInsets.only(bottom: 10.w),
          width: 44.w,
          height: 44.w,
          child: FloatingActionButton(
            elevation: 0.0,
            backgroundColor: Colors.white,
            onPressed: model.scrollToTop,
            child: Container(
              child: Image.asset(
                "assets/all_top_icon.png",
              ),
            ),
          ),
        ),
      ),
    );
  }
}

class ScrollToModel extends BaseModel {
  ScrollController scrollController = ScrollController();
  bool showFloatingButton = false;
  //记录是否是点击tab触发的事件
  bool taped = false;

  addScrollListener() {
    scrollController.addListener(() {
      if (scrollController.offset > 800 && showFloatingButton == false) {
        if (taped == true) {
          return;
        }
        showFloatingButton = true;
        notifyListeners();
      }
      if (scrollController.offset <= 800 && showFloatingButton == true) {
        if (taped == true) {
          return;
        }
        showFloatingButton = false;
        notifyListeners();
      }

      print('####################$showFloatingButton');
    });
  }

  scrollToTop() {
    scrollController.animateTo(0,
        duration: Duration(milliseconds: 300), curve: Curves.linear);
  }

  @override
  void dispose() {
    scrollController.dispose();
    super.dispose();
  }
}
